﻿USE tempdb;
GO

-- nawet niezłe te GROUPING SETS, ale może dałoby się jakoś posortować fajniej?
-- no da się, do tego stosujemy GROUPING()

;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	Rok			= YEAR(s.data_sprzedazy),
	Miesiac		= MONTH(s.data_sprzedazy),
	Dzien		= DAY(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)
SELECT
	GROUPING(Produkt),
	GROUPING(Rok),
	GROUPING(Miesiac),
	GROUPING(Dzien),
	Produkt,
	Rok,
	Miesiac,
	Dzien,
	sumaIlosc	= SUM(ilosc),
	sumaWartosc	= SUM(wartosc)
FROM Dane d
GROUP BY GROUPING SETS (
	(Produkt, Rok, Miesiac, Dzien),
	(Produkt, Rok),
	(Produkt, Rok, Miesiac),
	()
)
ORDER BY
	Produkt,
	Rok,
	Miesiac,
	Dzien

-- a teraz posortuj
;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	Rok			= YEAR(s.data_sprzedazy),
	Miesiac		= MONTH(s.data_sprzedazy),
	Dzien		= DAY(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)
SELECT
	Produkt,
	Rok,
	Miesiac,
	Dzien,
	sumaIlosc	= SUM(ilosc),
	sumaWartosc	= SUM(wartosc)
FROM Dane d
GROUP BY GROUPING SETS (
	(Produkt, Rok, Miesiac, Dzien),
	(Produkt, Rok),
	(Produkt, Rok, Miesiac),
	()
)
ORDER BY
	GROUPING(Produkt), Produkt,
	GROUPING(Rok), Rok,
	GROUPING(Miesiac), Miesiac,
	GROUPING(Dzien), Dzien




-- Jeszcze takie coś jak GROUPING_ID()
;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	Rok			= YEAR(s.data_sprzedazy),
	Miesiac		= MONTH(s.data_sprzedazy),
	Dzien		= DAY(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)
SELECT
	Grupowanie	= GROUPING_ID(Produkt, Rok, Miesiac, Dzien),
	Produkt,
	Rok,
	Miesiac,
	Dzien,
	sumaIlosc	= SUM(ilosc),
	sumaWartosc	= SUM(wartosc)
FROM Dane d
GROUP BY GROUPING SETS (
	(Produkt, Rok, Miesiac, Dzien),
	(Produkt, Rok),
	(Produkt, Rok, Miesiac),
	()
)
ORDER BY
	GROUPING(Produkt), Produkt,
	GROUPING(Rok), Rok,
	GROUPING(Miesiac), Miesiac,
	GROUPING(Dzien), Dzien

/*
-- dlaczego takie wartości kolumny Grupowanie?
----------- -------------------------------------------------- ----------- ----------- -----------
            8                                                  4           2           1
----------- -------------------------------------------------- ----------- ----------- -----------
Grupowanie  Produkt                                            Rok         Miesiac     Dzien       
----------- -------------------------------------------------- ----------- ----------- -----------

-- Uwaga! To są zsumowane wartości bitów, które nie są ustawione w grupowaniu!
*/