﻿USE tempdb;
GO

SELECT *
FROM Sprzedaz

-- pokaż sprzedaż pracowników w danym miesiącu
;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)
SELECT *
FROM Dane


/* a teraz pokaż to w formacie
                    | RokMiesiac1 | RokMiesiac2 | ... | RokMiesiacX
----------+---------+-------------+-------------+-----+-------------
Pracownik | Produkt | SUMA(ilosc) | SUMA(ilosc) | ... |  SUMA(ilosc)  

*/

-- najpierw podejście standardowe
;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)
SELECT
	Pracownik,
	Produkt,
	[201401]	= CASE WHEN RokMiesiac = 201401 THEN ilosc END,
	[201402]	= CASE WHEN RokMiesiac = 201402 THEN ilosc END,
	[201403]	= CASE WHEN RokMiesiac = 201403 THEN ilosc END,
	[201404]	= CASE WHEN RokMiesiac = 201404 THEN ilosc END,
	[201405]	= CASE WHEN RokMiesiac = 201405 THEN ilosc END,
	[201406]	= CASE WHEN RokMiesiac = 201406 THEN ilosc END,
	[201407]	= CASE WHEN RokMiesiac = 201407 THEN ilosc END,
	[201408]	= CASE WHEN RokMiesiac = 201408 THEN ilosc END,
	[201409]	= CASE WHEN RokMiesiac = 201409 THEN ilosc END,
	[201410]	= CASE WHEN RokMiesiac = 201410 THEN ilosc END,
	[201411]	= CASE WHEN RokMiesiac = 201411 THEN ilosc END,
	[201412]	= CASE WHEN RokMiesiac = 201412 THEN ilosc END
FROM Dane

-- mamy rozbicie na kolumny, to teraz sumujemy
;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)
SELECT
	Pracownik,
	Produkt,
	[201401]	= SUM(CASE WHEN RokMiesiac = 201401 THEN ilosc END),
	[201402]	= SUM(CASE WHEN RokMiesiac = 201402 THEN ilosc END),
	[201403]	= SUM(CASE WHEN RokMiesiac = 201403 THEN ilosc END),
	[201404]	= SUM(CASE WHEN RokMiesiac = 201404 THEN ilosc END),
	[201405]	= SUM(CASE WHEN RokMiesiac = 201405 THEN ilosc END),
	[201406]	= SUM(CASE WHEN RokMiesiac = 201406 THEN ilosc END),
	[201407]	= SUM(CASE WHEN RokMiesiac = 201407 THEN ilosc END),
	[201408]	= SUM(CASE WHEN RokMiesiac = 201408 THEN ilosc END),
	[201409]	= SUM(CASE WHEN RokMiesiac = 201409 THEN ilosc END),
	[201410]	= SUM(CASE WHEN RokMiesiac = 201410 THEN ilosc END),
	[201411]	= SUM(CASE WHEN RokMiesiac = 201411 THEN ilosc END),
	[201412]	= SUM(CASE WHEN RokMiesiac = 201412 THEN ilosc END)
FROM Dane
GROUP BY
	Pracownik,
	Produkt

-- trochę pisania jest (a jak potrzebne np. kolumn na dwa lata?)
-- polecenie PIVOT nam to skróci

-- co nam jest potrzebne do określenia pivota?
-- 1) Po czym grupujemy?
-- 2) Z której kolumny bierzemy atrybuty?
-- 3) Które wartości nas interesują?
-- 4) I jak je zliczać?


/*
Konstrukcja ogólna

SELECT kolumny_tabeli, wartosci_piwotowane
FROM tabela
PIVOT (
	funkcja_agregująca(wartość) FOR kolumna_piwotu IN (wartości_piwotowane)
)
*/

;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)

SELECT
	Pracownik,
	Produkt,
	[201401], [201402], [201403], [201404], [201405], [201406],
	[201407], [201408], [201409], [201410], [201411], [201412]
FROM Dane

	PIVOT (
		SUM(ilosc)
		-- taka konstrukcja zawiera wartości, które są niedozwolone
		-- z punktu widzenia nazw kolumn
		--FOR RokMiesiac IN (
		--	201401, 201402, 201403, 201404, 201405, 201406,
		--	201407, 201408, 201409, 201410, 201411, 201412
		--)
		-- musimy je wziąć w klamry lub apostrofy
		FOR RokMiesiac IN (
			[201401], [201402], [201403], [201404], [201405], [201406],
			[201407], [201408], [201409], [201410], [201411], [201412]
		)
	) p

-- Tadam! Ale - coś chyba nie tak, uruchom oba poprzednie polecenia razem i porównaj liczby rekordów

-- wyjdzie coś w stylu
-- (17 row(s) affected)
-- (38 row(s) affected)

-- skąd różnica? podpowiedź: które kolumny brane są do grupowania?
-- Czyli jak będzie dobrze?
;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc
	-- s.wartosc			-- <-- usuwamy wartość, bo grupowanie jest po 
							-- wszystkich wartościach zbioru WEJŚCIOWEGO,
							-- które nie zostały wymienione w klauzuli PIVOT
							-- nie po kolumnach z SELECT
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)

SELECT
	Pracownik,
	Produkt,
	[201401], [201402], [201403], [201404], [201405], [201406],
	[201407], [201408], [201409], [201410], [201411], [201412]
FROM Dane

	PIVOT (
		SUM(ilosc)
		FOR RokMiesiac IN (
			[201401], [201402], [201403], [201404], [201405], [201406],
			[201407], [201408], [201409], [201410], [201411], [201412]
		)
	) p


-- jeszcze gdzie są elementy wymagane do PIVOTa:
-- 1) Po czym grupujemy?
-- 2) Z której kolumny bierzemy atrybuty?
-- 3) Które wartości nas interesują?
-- 4) I jak je zliczać?

;WITH Dane AS (				-- 1)
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)

SELECT
	Pracownik,
	Produkt,
	[201401], [201402], [201403], [201404], [201405], [201406],
	[201407], [201408], [201409], [201410], [201411], [201412]
FROM Dane

	PIVOT (
		SUM(ilosc)															-- 4)
		FOR RokMiesiac IN (													-- 2)
			[201401], [201402], [201403], [201404], [201405], [201406],		-- 3)
			[201407], [201408], [201409], [201410], [201411], [201412]		-- 3)
		)
	) p



-- popatrz jeszcze raz na zapytania z grupowaniem ręcznie i z PIVOTem i obejrzyj plany zapytania
-- zwróć uwagę na koszt zapytań (SELECT) i Stream Aggregate:


;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)
SELECT
	Pracownik,
	Produkt,
	[201401]	= SUM(CASE WHEN RokMiesiac = 201401 THEN ilosc END),
	[201402]	= SUM(CASE WHEN RokMiesiac = 201402 THEN ilosc END),
	[201403]	= SUM(CASE WHEN RokMiesiac = 201403 THEN ilosc END),
	[201404]	= SUM(CASE WHEN RokMiesiac = 201404 THEN ilosc END),
	[201405]	= SUM(CASE WHEN RokMiesiac = 201405 THEN ilosc END),
	[201406]	= SUM(CASE WHEN RokMiesiac = 201406 THEN ilosc END),
	[201407]	= SUM(CASE WHEN RokMiesiac = 201407 THEN ilosc END),
	[201408]	= SUM(CASE WHEN RokMiesiac = 201408 THEN ilosc END),
	[201409]	= SUM(CASE WHEN RokMiesiac = 201409 THEN ilosc END),
	[201410]	= SUM(CASE WHEN RokMiesiac = 201410 THEN ilosc END),
	[201411]	= SUM(CASE WHEN RokMiesiac = 201411 THEN ilosc END),
	[201412]	= SUM(CASE WHEN RokMiesiac = 201412 THEN ilosc END)
FROM Dane
GROUP BY
	Pracownik,
	Produkt

;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)

SELECT
	Pracownik,
	Produkt,
	[201401], [201402], [201403], [201404], [201405], [201406],
	[201407], [201408], [201409], [201410], [201411], [201412]
FROM Dane

	PIVOT (
		SUM(ilosc)
		FOR RokMiesiac IN (
			[201401], [201402], [201403], [201404], [201405], [201406],
			[201407], [201408], [201409], [201410], [201411], [201412]
		)
	) p

